<template lang="pug">
.slides_plugin
  transition(
    :key='visible',
    enter-active-class='animate__animated animate__fadeIn animate__fast',
    leave-active-class='animate__animated animate__fadeOut animate__fast'
  )
    .content.z-max(v-if='visible && slides.content')
      .column.justify-center.full-height
        .relative-position
          .slide.bordered(:style='{ height: height, width: width }')
            transition(
              mode='out-in',
              enter-active-class='animate__animated animate__fadeIn animate__fast',
              leave-active-class='animate__animated animate__fadeOut animate__fast'
            )
              Markdown.full-height(
                v-bind:style='slides.style',
                :demo='demo',
                :content='slides.content[currentslide]',
                :key='currentslide',
                :sequenceinputs='sequenceinputs',
                :meetinginputs='meetinginputs'
              )
          transition(
            mode='out-in',
            enter-active-class='animate__animated animate__fadeIn animate__fast',
            leave-active-class='animate__animated animate__fadeOut animate__fast'
          )
            div(v-if='slides.annotation && annotation', :key='currentslide')
              .postit
                //- #{'<svg width="0" height="0">          <defs>            <clipPath id="stickyClip" clipPathUnits="objectBoundingBox">              <path                d="M 0 0 Q 0 0.69, 0.03 0.96 0.03 0.96, 1 0.96 Q 0.96 0.69, 0.96 0 0.96 0, 0 0"                stroke-linejoin="round"               stroke-linecap="square"      /></clipPath></defs></svg>}
                Markdown(:content='annotation', :key='currentslide')
</template>

<script>
import Markdown from './Markdown.vue';

export default {
  name: 'SlidesOverlay',
  props: {
    firebase: {
      required: true,
    },
    context: {
      required: false,
    },
    demo: {
      default: false,
    },
  },
  components: {
    Markdown,
  },
  computed: {
    currentslide() {
      if (typeof this.slides.currentslide === 'undefined') {
        if (this.context.host) {
          try {
            this.firebase
              .ref(`config/${this.context.meetingid}/current/currentState/plugins/slides/currentslide`)
              .set(0);
          } catch {
            console.log('Not host, cant set currentslide');
          }
        }
        return 0;
      } else return this.slides.currentslide;
    },
    annotation() {
      // console.log(this.slides.annotation);
      if (this.slides.annotation) {
        if (this.slides.annotation.type === 'sequence') {
          return this.sequenceinputs[
            `_annotation_${this.slides.annotation.prefix || '*'}_${this.current.currentSection}_${
              this.slides.currentslide
            }`
          ];
        } else {
          return this.meetinginputs[`_annotation_${this.current.currentSection}_${this.slides.currentslide}`];
        }
      } else return '';
    },
    ratio() {
      return this.slides.ratio || 4.0 / 3.0;
    },
    height() {
      return `${550 / this.ratio}px`;
      //- height: 412px;
      //- width: 550px;
    },
    width() {
      return '550px';
    },
    visible() {
      if (typeof this.slides.visible === 'undefined') {
        if (this.context.host) {
          try {
            this.firebase.ref(`config/${this.context.meetingid}/current/currentState/plugins/slides/visible`).set(true);
          } catch {
            console.log('Not host, cant set currentslide');
          }
        }
        return true;
      } else return this.slides.visible;
    },
    getStyle() {
      return this.slides.style || {};
    },
  },
  data: () => {
    return {
      slides: {},
      current: {},
      meetinginputs: {},
      sequenceinputs: {},
    };
  },
  watch: {
    firebase: {
      immediate: true,
      handler() {
        // console.log(this.firebase);
        this.$rtdbBind(
          'slides',
          this.firebase.ref(`config/${this.context.meetingid}/current/currentState/plugins/slides`),
        );

        // console.log(`Context loaded by Slides:`);
        // console.log(this.context);

        // console.log(`Sequence ID loading into slides: ${this.context.sequenceid}`);
        if (this.context.sequenceid)
          this.$rtdbBind('sequenceinputs', this.firebase.ref(`sequence/slides/${this.context.sequenceid}/current`));

        this.$rtdbBind('meetinginputs', this.firebase.ref(`data/slides/${this.context.meetingid}/current`));

        this.$rtdbBind('current', this.firebase.ref(`config/${this.context.meetingid}/current`));
      },
    },
  },
};
</script>

<style src="animate.css/animate.css">
/* global styles */
</style>

<style lang="scss"></style>
